<?php

namespace App\Http\Controllers\Api;

use App\{Device, Template, Setting};
use App\Http\Controllers\Controller;
use App\Services\ProvisionFileService;
use Illuminate\Http\Request;

class ProvisionController extends Controller
{
    public function __invoke($mac)
    {
        $device = Device::with(['model.brand', 'template.setting'])->where('mac', $mac)->firstOrFail();

        $result = ProvisionFileService::execute($device);

        if ($result !== true) return response()->json(['message' => $result], 500);

        return ['message' => __('messages.provisioning.created')];
    }
}
